package com.mitchellbosecke.benchmark;

import java.io.StringWriter;
import java.io.Writer;

import org.openjdk.jmh.annotations.Benchmark;
import org.openjdk.jmh.annotations.Setup;

import httl.Engine;
import httl.Template;

public class Httl extends BaseBenchmark {
	private Template template;

	@Setup
	public void setup() {
		try {
			template = Engine.getEngine().getTemplate("templates/stocks.httl");
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@Benchmark
	public String benchmark() {
		Writer writer = new StringWriter();
		try {
			template.render(getContext(), writer);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return writer.toString();
	}

	public static void main(String[] a) {
		Httl httl = new Httl();
		httl.setup();
		long start = System.currentTimeMillis();
		String response = httl.benchmark();
		long end = System.currentTimeMillis();
		System.out.println((end - start) + " : " + response);
	}

}
