package com.mitchellbosecke.benchmark;

import java.io.IOException;
import java.util.List;

import org.openjdk.jmh.annotations.Benchmark;
import org.openjdk.jmh.annotations.Setup;

import com.mitchellbosecke.benchmark.model.Stock;

/**
 * Benchmark for Rocker template engine by Fizzed.
 * 
 * https://github.com/fizzed/rocker
 * 
 * @author joelauer
 */
public class Rocker extends BaseBenchmark {
	private List<Stock> items;

	@Setup
	public void setup() throws IOException {
		// no config needed, replicate stocks from context
		this.items = Stock.dummyItems();
	}

	@Benchmark
	public String benchmark() throws IOException {
		return com.fizzed.rocker.Rocker.template("templates/stocks.rocker.raw").bind("items", this.items).render().toString();
	}
}
